#Vang, behavior analysis redone from combining fish behaviour from the initial analysis

rm(list=ls(all=TRUE))

library(dplyr)
library(tidyselect)
library(readxl) #if excel files
Data    <- read_excel("Redfish_at_the_trawl_mouth.xlsx")
Data<-subset(Data, Outcome != "unknown") 
Data1<-subset(Data, Turn != "y")
Data1<-subset(Data1, Position1 != "N")
Data1<-subset(Data1, Position2 != "T")
Data1<-subset(Data1, Rcontact != "T")
Data1<-subset(Data1, Swimming_behavior != "UP")
Data1$Outcome <-as.factor(Data1$Outcome)

Data1<-select(Data1, -Capture_location, -Escape_location, -Date, -Notes)
Data1<-na.omit(Data1) 

#combining swimming transversing (sideways) to swimming with the trawl
library(stringr)
Data1$Swimming_behavior2<-Data1$Swimming_behavior
Data1$Swimming_behavior<- str_replace(Data1$Swimming_behavior, "Transversing", "With")
#combining swimming Up and Dow  to swimming against the trawl
Data1$Swimming_behavior<- str_replace(Data1$Swimming_behavior, "Up", "Against")
Data1$Swimming_behavior<- str_replace(Data1$Swimming_behavior, "Down", "Against")

#summing swimming with, against, and PS to No change
Data1$Swimming_behavior2<-str_replace(Data1$Swimming_behavior2, "Transversing", "No")
Data1$Swimming_behavior2<-str_replace(Data1$Swimming_behavior2, "With", "No")
Data1$Swimming_behavior2<-str_replace(Data1$Swimming_behavior2, "Against", "No")
Data1$Swimming_behavior2<-str_replace(Data1$Swimming_behavior2, "NS", "No")

####For all data including on and off-bottom
##Outcome
Capture<-subset(Data1, Outcome =="caught")#1168
Escape<-subset(Data1, Outcome =="escape")#931
##Position1
PosB<-subset(Data1, Position1 =="B")#1535
PosT<-subset(Data1, Position1 =="T")#564
PoBcapture<-subset(PosB, Outcome =="caught")#754
PoBescape<-subset(PosB, Outcome =="escape")#781
PoTcapture<-subset(PosT, Outcome =="caught")#414
PoTescape<-subset(PosT, Outcome =="escape")#150
poBagainst<-subset(PosB, Swimming_behavior =="Against")#959
poBwith<-subset(PosB, Swimming_behavior =="With")#377
poBNS<-subset(PosB, Swimming_behavior =="NS")#199

poTagainst<-subset(PosT, Swimming_behavior =="Against")#348
poTwith<-subset(PosT, Swimming_behavior =="With")#84
poTNS<-subset(PosT, Swimming_behavior =="NS")#132


##Swimming behavior
Against<-subset(Data1, Swimming_behavior =="Against")#1307
With<-subset(Data1, Swimming_behavior =="With")#461
#Up<-subset(Data1, Swimming_behavior =="Up")#714
#Down<-subset(Data1, Swimming_behavior =="Down")#130
#Transversing<-subset(Data1, Swimming_behavior =="Transversing")#197
NS<-subset(Data1, Swimming_behavior =="NS")#331

Againstcap<-subset(Against, Outcome =="caught")#940
Againstescape<-subset(Against, Outcome =="escape")#367
Withcap<-subset(With, Outcome =="caught")#72
Withescape<-subset(With, Outcome =="escape")#192
#Upcap<-subset(Up, Outcome =="caught")#708
#Upescape<-subset(Up, Outcome =="escape")#6
#Downcap<-subset(Down, Outcome =="caught")#7
#Downescape<-subset(Down, Outcome =="escape")#123
#Transversingcap<-subset(Transversing, Outcome =="caught")#31
#Transversingescape<-subset(Transversing, Outcome =="escape")#166
NScap<-subset(NS, Outcome =="caught")#125
NSescape<-subset(NS, Outcome =="escape")#206

#Swimming_behaviour2
Up<-subset(Data1, Swimming_behavior2 =="Up")#714
Down<-subset(Data1, Swimming_behavior2 =="Down")#130
No<-subset(Data1, Swimming_behavior2 =="No")#1255

Upcap<-subset(Up, Outcome =="caught")#708
Upescape<-subset(Up, Outcome =="escape")#6
Downcap<-subset(Down, Outcome =="caught")#7
Downescape<-subset(Down, Outcome =="escape")#123
Nocap<-subset(No, Outcome =="caught")#453
Noescape<-subset(No, Outcome =="escape")#802

##Turn
Yes<-subset(Data1, Turn =="Y")#805
No<-subset(Data1, Turn =="N")#1294
Yescap<-subset(Yes, Outcome =="caught")#490
Yesescape<-subset(Yes, Outcome =="escape")#315
Nocap<-subset(No, Outcome =="caught")#678
Noescape<-subset(No, Outcome =="escape")#616


##Fcontact
FY<-subset(Data1, Fcontact =="Y")#36
FN<-subset(Data1, Fcontact =="N")#2063
FYcap<-subset(FY, Outcome =="caught")#28
FYescape<-subset(FY, Outcome =="escape")#8
FNcap<-subset(FN, Outcome =="caught")#1140
FNescape<-subset(FN, Outcome =="escape")#923

##Rcontact
RY<-subset(Data1, Rcontact =="Y")#385
RN<-subset(Data1, Rcontact =="N")#1714
RYcap<-subset(RY, Outcome =="caught")#121
RYescape<-subset(RY, Outcome =="escape")#264
RNcap<-subset(RN, Outcome =="caught")#1047
RNescape<-subset(RN, Outcome =="escape")#667


#Modeling the behaviour
library(lme4)
#with Swimming_behavior2 with Swimming up, down, and No change (swimming with, against, and Passive swimming)
m<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + Clearance +Day+ (1 | Tow), data=Data1, family=binomial)
m1<-glmer(Outcome ~ 1+ Position1 + (1 | Tow), data=Data1, family=binomial)
m2<-glmer(Outcome ~ 1+ Swimming_behavior + (1 | Tow), data=Data1, family=binomial)
m3<-glmer(Outcome ~ 1+ Swimming_behavior2 + (1 | Tow), data=Data1, family=binomial)
m4<-glmer(Outcome ~ 1+ Rcontact + (1 | Tow), data=Data1, family=binomial)
m5<-glmer(Outcome ~ 1+ Time_Time + (1 | Tow), data=Data1, family=binomial)
m6<-glmer(Outcome ~ 1+ Day + (1 | Tow), data=Data1, family=binomial)
m7<-glmer(Outcome ~ 1+ Clearance + (1 | Tow), data=Data1, family=binomial)
m8<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + (1 | Tow), data=Data1, family=binomial)
m9<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior2 + (1 | Tow), data=Data1, family=binomial)
m10<-glmer(Outcome ~ 1+ Position1 + Rcontact + (1 | Tow), data=Data1, family=binomial)
m11<-glmer(Outcome ~ 1+ Position1 + Time_Time + (1 | Tow), data=Data1, family=binomial)
m12<-glmer(Outcome ~ 1+ Position1 + Clearance + (1 | Tow), data=Data1, family=binomial)
m13<-glmer(Outcome ~ 1+ Position1 + Day + (1 | Tow), data=Data1, family=binomial)
m14<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + (1 | Tow), data=Data1, family=binomial)
m15<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Rcontact + (1 | Tow), data=Data1, family=binomial)
m16<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Time_Time + (1 | Tow), data=Data1, family=binomial)
m17<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Day + (1 | Tow), data=Data1, family=binomial)
m18<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Clearance + (1 | Tow), data=Data1, family=binomial)

m19<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + (1 | Tow), data=Data1, family=binomial)
m20<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Time_Time + (1 | Tow), data=Data1, family=binomial)
m21<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Clearance + (1 | Tow), data=Data1, family=binomial)
m22<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Day + (1 | Tow), data=Data1, family=binomial)

m23<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + (1 | Tow), data=Data1, family=binomial)
m24<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Clearance + (1 | Tow), data=Data1, family=binomial)
m25<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Day + (1 | Tow), data=Data1, family=binomial)

m26<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
m27<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + Day + (1 | Tow), data=Data1, family=binomial)


m28<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + (1 | Tow), data=Data1, family=binomial)
m29<-glmer(Outcome ~ 1+ Swimming_behavior + Rcontact  + (1 | Tow), data=Data1, family=binomial)
m30<-glmer(Outcome ~ 1+ Swimming_behavior + Time_Time + (1 | Tow), data=Data1, family=binomial)
m31<-glmer(Outcome ~ 1+ Swimming_behavior + Clearance  + (1 | Tow), data=Data1, family=binomial)
m32<-glmer(Outcome ~ 1+ Swimming_behavior + Day + (1 | Tow), data=Data1, family=binomial)

m33<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Rcontact + (1 | Tow), data=Data1, family=binomial)
m34<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Time_Time + (1 | Tow), data=Data1, family=binomial)
m35<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Clearance + (1 | Tow), data=Data1, family=binomial)
m36<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Day + (1 | Tow), data=Data1, family=binomial)

m37<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Rcontact + Time_Time + (1 | Tow), data=Data1, family=binomial)
m38<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Rcontact + Clearance + (1 | Tow), data=Data1, family=binomial)
m39<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Rcontact + Day + (1 | Tow), data=Data1, family=binomial)

m40<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Rcontact + Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
m41<-glmer(Outcome ~ 1+ Swimming_behavior + Swimming_behavior2  + Rcontact + Time_Time + Day + (1 | Tow), data=Data1, family=binomial)

m42<-glmer(Outcome ~ 1+ Swimming_behavior2  + Rcontact + (1 | Tow), data=Data1, family=binomial)
m43<-glmer(Outcome ~ 1+ Swimming_behavior2  + Time_Time + (1 | Tow), data=Data1, family=binomial)
m44<-glmer(Outcome ~ 1+ Swimming_behavior2  + Clearance + (1 | Tow), data=Data1, family=binomial)
m45<-glmer(Outcome ~ 1+ Swimming_behavior2  + Day + (1 | Tow), data=Data1, family=binomial)

m46<-glmer(Outcome ~ 1+ Swimming_behavior2  + Rcontact + Time_Time + (1 | Tow), data=Data1, family=binomial)
m47<-glmer(Outcome ~ 1+ Swimming_behavior2  + Rcontact + Clearance + (1 | Tow), data=Data1, family=binomial)
m48<-glmer(Outcome ~ 1+ Swimming_behavior2  + Rcontact + Day + (1 | Tow), data=Data1, family=binomial)

m49<-glmer(Outcome ~ 1+ Swimming_behavior2  + Rcontact + Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
m50<-glmer(Outcome ~ 1+ Swimming_behavior2  + Rcontact + Time_Time + Day + (1 | Tow), data=Data1, family=binomial)

m51<-glmer(Outcome ~ 1+ Rcontact + Time_Time + (1 | Tow), data=Data1, family=binomial)
m52<-glmer(Outcome ~ 1+ Rcontact + Clearance + (1 | Tow), data=Data1, family=binomial)
m53<-glmer(Outcome ~ 1+ Rcontact + Day + (1 | Tow), data=Data1, family=binomial)

m54<-glmer(Outcome ~ 1+ Rcontact + Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
m55<-glmer(Outcome ~ 1+ Rcontact + Time_Time + Day + (1 | Tow), data=Data1, family=binomial)


m56<-glmer(Outcome ~ 1+ Rcontact + Time_Time + (1 | Tow), data=Data1, family=binomial)
m57<-glmer(Outcome ~ 1+ Rcontact + Clearance + (1 | Tow), data=Data1, family=binomial)
m58<-glmer(Outcome ~ 1+ Rcontact + Day + (1 | Tow), data=Data1, family=binomial)

m59<-glmer(Outcome ~ 1+ Rcontact + Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
m60<-glmer(Outcome ~ 1+ Rcontact + Time_Time + Day + (1 | Tow), data=Data1, family=binomial)

m61<-glmer(Outcome ~ 1+ Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
m62<-glmer(Outcome ~ 1+ Time_Time + Day + (1 | Tow), data=Data1, family=binomial)
m63<-glmer(Outcome ~ 1+ Day + (1 | Tow), data=Data1, family=binomial)

m64<-glmer(Outcome ~ 1+ Clearance + Day + (1 | Tow), data=Data1, family=binomial)
m65<-glmer(Outcome ~ 1+ (1 | Tow), data=Data1, family=binomial)



library("bbmle")
AICctab(m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, m16, m17, m18, m19, m20, m21, m22, m23, m24, m25, m26, m27, m28, m29, m30, m31, m32, m33, m34, m35, m36, m37, m38,m39, m40, m41, m42, m43, m44, m45, m46, m47, m48, m49, m50, m51, m52, m53, m54, m55, m56, m57, m58, m59, m60, m61, m62, m63, m64, m65, base=TRUE, weights=TRUE) #delta AICc - correction for slall salple sizes



#Modeling the behaviour
library(glmulti)    # finds the BEST model
library(flextable)  # beautifies tables
library(tictoc)     # checks running time



# wrapper function for linear mixed-models
glmer.glmulti <- function(formula,data, random="",...){
  glmer(paste(deparse(formula),random), 
        family = binomial, 
        data=data, ...)
}

# define formula
form_glmulti = as.formula(paste("Out2 ~ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + Clearance + Day"))
# multi selection for glmer

new1<-Data1

new1<-new1[,c(1,2,8,10,11,14,15,16,21,22)]#Drop column

new1$Out2<-ifelse(new1$Outcome=="caught",1,new1$Outcome)
new1$Out2<-ifelse(new1$Outcome=="escape",0,new1$Out2)


tic()
mfit <- glmulti(form_glmulti,random="+(1 | Tow)", 
                data = new1, 
                method = "h",             # "d", or "h", or "g"........h is exhaustive (all models)
                fitfunc = glmer.glmulti,  # Type of model (LM, GLM etc.) 
                crit = "bic",            # AICC corrected AIC for small samples 
                intercept = TRUE,
                marginality = FALSE,
                level = 1,                # 2 with interactions, 1 without  
                confsetsize = 128         # Keep 128 best models..........2^7=128
)
toc() # 117.84 sec elapsed, 128 models

print(mfit)
plot(mfit)

table_glm<-weightable(mfit)[1:128,] %>% 
  regulartable() %>%       # beautifying tables
  autofit()
table_glm

plot(mfit, type = "s")

best_model <- mfit@objects[[2]]

car::Anova(best_model)


#run after "behavior analysis_ms3.1

library(DHARMa) #for residual checks

set.seed(9999) #set the seed

#overdispersion test
overdisp_fun <- function(model) {
  rdf <- df.residual(model)
  rp <- residuals(model,type="pearson")
  Pearson.chisq <- sum(rp^2)
  prat <- Pearson.chisq/rdf
  pval <- pchisq(Pearson.chisq, df=rdf, lower.tail=FALSE)
  c(chisq=Pearson.chisq,ratio=prat,rdf=rdf,p=pval)
}

#check for overdispersion
overdisp_fun(m14) # ratio 1.0365186, ~ 1 = equaidispersed; p = 0.1195422

#overdispersion test 2
sim_m1 <- simulateResiduals(m14, refit=T) #simulation...slow, thus commented out
plot(sim_m1)
testDispersion(sim_m1) # dispersion = 1.0928, p-value = 0.144..agrees...equadispersed

simulationOutput = simulateResiduals(fittedModel = m14, n= 1000) #use larger n later
testResiduals(simulationOutput) #looks good 

plotQQunif(simulationOutput) # looks good

plotResiduals(simulationOutput) # looks good

#m14<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + (1 | Tow), data=Data1, family=binomial)

plotResiduals(simulationOutput, form = Data1$Position1) # looks good 

plotResiduals(simulationOutput, form = Data1$Swimming_behavior) # looks good  

plotResiduals(simulationOutput, form = Data1$Swimming_behavior2) # looks good  


#m26<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + Clearance + (1 | Tow), data=Data1, family=binomial)
#variables not in 'good' model

plotResiduals(simulationOutput, form = Data1$Time_Time) # looks good

plotResiduals(simulationOutput, form = Data1$Clearance) # looks good

plotResiduals(simulationOutput, form = Data1$Oreintation) # looks good

plotResiduals(simulationOutput, form = Data1$Rcontact) # looks good  

#model<-glmer(Outcome ~ 1+ Position1 + Swimming_behavior + Swimming_behavior2 + Rcontact + Time_Time + Clearance + Day + (1 | Tow), data=Data1, family=binomial)
#added Day and Orientation
#tried orientation, model could not converge

plotResiduals(simulationOutput, form = Data1$Day) # looks good  

#gamlss

library(gamlss)
library(gamlss.dist)
library(gamlss.add)

#Binomial   
m0<-gamlss(Outcome ~ 1, family = BI, data = Data1)
m1<-gamlss(Outcome ~ Position1 + Swimming_behavior + Swimming_behavior2,random=~1|Tow, family = BI, data = Data1)

GAIC(m0,m1)

wp(m1,ylim.all = 2.5)

library(car)

vif(m14) # values are around 1, multicollinearity is not a concern 

# GVIF Df GVIF^(1/(2*Df))
# Position1          1.395198  1        1.181185
# Swimming_behavior  1.385680  2        1.084965
# Swimming_behavior2 1.485754  2        1.104045

#Categorical vs. Categorical variable comparisons 

new<-Data1

new<-new[,c(2,8,10,11,14,15,16,21,22)]#Drop column


#Comparing Variables to Outcome

plot(new$Outcome,new$Time_Time) #no effect from Time

library(ggplot2)

# grouped bar plot
#Position
ggplot(new, 
       aes(x = Position1, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #Bottom almost even (capture/escape), Top over 2x were caught

#Orientation
ggplot(new, 
       aes(x = Orientation, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #no clear pattern

#Swimming behavior 1
ggplot(new, 
       aes(x = Swimming_behavior, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #Against had many more captures

#Swimming behavior 2
ggplot(new, 
       aes(x = Swimming_behavior2, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #Up (almost all caught), no change (more escapes), Down (mostly escaped)

#Contact
ggplot(new, 
       aes(x = Rcontact, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #No, more likely caught; Yes, more likely escaped

#Clearance
ggplot(new, 
       aes(x = Clearance, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #Not much of an effect, more caught for each

#Day
ggplot(new, 
       aes(x = Day, 
           fill = Outcome)) + 
  geom_bar(position = "dodge") #Not much of an effect, more caught for each 

# create a table
tbl <- xtabs(~Outcome + Position1 + Swimming_behavior + Swimming_behavior2, new)
ftable(tbl)

# create a mosaic plot from the table
#The units are in standard deviations, 
#so a residual greater than 2 or less than -2 represents a departure from independence significant at the 95% level.

library(vcd)
mosaic(tbl, main = "Title")

mosaic(tbl, 
       shade = TRUE,
       legend = TRUE,
       # labeling_args = list(set_varnames = c(Position1 = "Position",
       #                                       Swimming_behavior = "Swimming behavior 1",
       #                                       Swimming_behavior2 = "Swimming behavior 2")),
       # set_labels = list(Position1 = c("Top", "Bottom"),
       #                   Swimming_behavior = c("With", "Against", "No change"),
       #                   Swimming_behavior2 = c("Up", "Down", "No change")),
       main = "With Dependent variable")

# create a mosaic plot from the table
library(vcd)
mosaic(tbl, main = "With Dependent variable")

# create a table
tbl <- xtabs(~Position1 + Swimming_behavior + Swimming_behavior2, new)
ftable(tbl)

# create a mosaic plot from the table
library(vcd)
mosaic(tbl, main = "Title")

mosaic(tbl, 
       shade = TRUE,
       legend = TRUE,
       labeling_args = list(set_varnames = c(Position1 = "Position",
                                             Swimming_behavior = "Swimming behavior 1",
                                             Swimming_behavior2 = "Swimming behavior 2")),
       set_labels = list(Position1 = c("Top", "Bottom"),
                         Swimming_behavior = c("With", "Against", "No change"),
                         Swimming_behavior2 = c("Up", "Down", "No change")),
       main = "No Dependent variable")

mosaic(tbl, 
       shade = TRUE,
       legend = TRUE,
       # labeling_args = list(set_varnames = c(Position1 = "Position",
       #                                       Swimming_behavior = "Swimming behavior 1",
       #                                       Swimming_behavior2 = "Swimming behavior 2")),
       # set_labels = list(Position1 = c("Top", "Bottom"),
       #                   Swimming_behavior = c("With", "Against", "No change"),
       #                   Swimming_behavior2 = c("Up", "Down", "No change")),
       main = "Title")

